=== debian/changelog ===
hipsparse (5.3.3+dfsg-2~deb12u1) bookworm; urgency=medium

  * Team upload.
  * Upload directly to bookworm, as per the RT.

 -- Christian Kastner <ckk@debian.org>  Thu, 01 Jun 2023 18:59:00 +0200

hipsparse (5.3.3+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Cordell Bloor ]
  * d/control: explicitly depend on libamdhip64-dev
    hipsparse.h includes hip/hip_complex.h and hip/hip_runtime.h, so users
    must have the hip headers installed to use the hipsparse headers.
    (Closes: #1035789)

 -- Christian Kastner <ckk@debian.org>  Sun, 28 May 2023 17:17:36 +0200

hipsparse (5.3.3+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1023092)

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 24 Jan 2023 03:35:25 -0700
