=== debian/control ===
Source: hipsparse
Section: devel
Homepage: https://github.com/rocmsoftwareplatform/hipsparse
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipsparse.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipsparse
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               rocm-cmake (>= 5.3.0),
               gfortran,
               hipcc,
               libamd-comgr-dev,
               libhsa-runtime-dev,
               libamdhip64-dev,
               librocsparse-dev,
               libgtest-dev <!nocheck>
Rules-Requires-Root: no

Package: libhipsparse0
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for sparse linear algebra on the GPU - library
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE library.

Package: libhipsparse-dev
Section: libdevel
Architecture: any
Depends: libhipsparse0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev
Description: portable interface for sparse linear algebra on the GPU - headers
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE development headers.
