=== debian/rules ===
#!/usr/bin/make -f
export VERBOSE=1

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF

# Disable tests for now. They require matricies from the
# SuiteSparse Matrix Collection, which has not been packaged.
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON
#endif

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

#override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	set -e \
#	; if [ -r /dev/kfd ] \
#	; then obj-$(DEB_BUILD_MULTIARCH)/clients/staging/hipsparse-test \
#	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
#	;      echo "W: tests skipped." \
#	; fi
#endif
