=== docs/source/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.8
# by the following command:
#
#    pip-compile docs/source/requirements.in
#
alabaster==0.7.12
    # via sphinx
asttokens==2.2.0
    # via stack-data
attrs==22.1.0
    # via
    #   jsonschema
    #   jupyter-cache
babel==2.10.3
    # via sphinx
backcall==0.2.0
    # via ipython
beautifulsoup4==4.11.1
    # via pydata-sphinx-theme
breathe==4.31.0
    # via -r docs/source/requirements.in
certifi==2022.6.15
    # via requests
charset-normalizer==2.1.0
    # via requests
click==8.1.3
    # via
    #   jupyter-cache
    #   sphinx-external-toc
debugpy==1.6.4
    # via ipykernel
decorator==5.1.1
    # via ipython
docutils==0.16
    # via
    #   -r docs/source/requirements.in
    #   breathe
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx
entrypoints==0.4
    # via jupyter-client
executing==1.2.0
    # via stack-data
fastjsonschema==2.16.2
    # via nbformat
greenlet==2.0.1
    # via sqlalchemy
idna==3.3
    # via requests
imagesize==1.4.1
    # via sphinx
importlib-metadata==5.1.0
    # via
    #   jupyter-cache
    #   myst-nb
importlib-resources==5.10.0
    # via jsonschema
ipykernel==6.17.1
    # via myst-nb
ipython==8.7.0
    # via
    #   ipykernel
    #   myst-nb
jedi==0.18.2
    # via ipython
jinja2==3.1.2
    # via
    #   myst-parser
    #   sphinx
jsonschema==4.17.3
    # via nbformat
jupyter-cache==0.5.0
    # via myst-nb
jupyter-client==7.4.7
    # via
    #   ipykernel
    #   nbclient
jupyter-core==5.1.0
    # via
    #   jupyter-client
    #   nbformat
linkify-it-py==1.0.3
    # via myst-parser
markdown-it-py==2.1.0
    # via
    #   mdit-py-plugins
    #   myst-parser
markupsafe==2.1.1
    # via jinja2
matplotlib-inline==0.1.6
    # via
    #   ipykernel
    #   ipython
mdit-py-plugins==0.3.1
    # via myst-parser
mdurl==0.1.2
    # via markdown-it-py
myst-nb==0.17.1
    # via -r docs/source/requirements.in
myst-parser[linkify]==0.18.1
    # via
    #   -r docs/source/requirements.in
    #   myst-nb
nbclient==0.5.13
    # via
    #   jupyter-cache
    #   myst-nb
nbformat==5.7.0
    # via
    #   jupyter-cache
    #   myst-nb
    #   nbclient
nest-asyncio==1.5.6
    # via
    #   ipykernel
    #   jupyter-client
    #   nbclient
packaging==21.3
    # via
    #   ipykernel
    #   pydata-sphinx-theme
    #   sphinx
parso==0.8.3
    # via jedi
pexpect==4.8.0
    # via ipython
pickleshare==0.7.5
    # via ipython
pkgutil-resolve-name==1.3.10
    # via jsonschema
platformdirs==2.5.4
    # via jupyter-core
prompt-toolkit==3.0.33
    # via ipython
psutil==5.9.4
    # via ipykernel
ptyprocess==0.7.0
    # via pexpect
pure-eval==0.2.2
    # via stack-data
pydata-sphinx-theme==0.8.1
    # via sphinx-book-theme
pygments==2.12.0
    # via
    #   ipython
    #   sphinx
pyparsing==3.0.9
    # via packaging
pyrsistent==0.19.2
    # via jsonschema
python-dateutil==2.8.2
    # via jupyter-client
pytz==2022.1
    # via babel
pyyaml==6.0
    # via
    #   jupyter-cache
    #   myst-nb
    #   myst-parser
    #   sphinx-book-theme
    #   sphinx-external-toc
pyzmq==24.0.1
    # via
    #   ipykernel
    #   jupyter-client
requests==2.28.1
    # via sphinx
six==1.16.0
    # via
    #   asttokens
    #   python-dateutil
snowballstemmer==2.2.0
    # via sphinx
soupsieve==2.3.2.post1
    # via beautifulsoup4
sphinx==4.3.1
    # via
    #   -r docs/source/requirements.in
    #   breathe
    #   myst-nb
    #   myst-parser
    #   pydata-sphinx-theme
    #   sphinx-book-theme
    #   sphinx-copybutton
    #   sphinx-design
    #   sphinx-external-toc
sphinx-book-theme==0.3.3
    # via -r docs/source/requirements.in
sphinx-copybutton==0.5.1
    # via -r docs/source/requirements.in
sphinx-design==0.3.0
    # via -r docs/source/requirements.in
sphinx-external-toc==0.3.1
    # via -r docs/source/requirements.in
sphinxcontrib-applehelp==1.0.2
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.0
    # via sphinx
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
sqlalchemy==1.4.44
    # via jupyter-cache
stack-data==0.6.2
    # via ipython
tabulate==0.9.0
    # via jupyter-cache
tornado==6.2
    # via
    #   ipykernel
    #   jupyter-client
traitlets==5.6.0
    # via
    #   ipykernel
    #   ipython
    #   jupyter-client
    #   jupyter-core
    #   matplotlib-inline
    #   nbclient
    #   nbformat
typing-extensions==4.4.0
    # via
    #   myst-nb
    #   myst-parser
uc-micro-py==1.0.1
    # via linkify-it-py
urllib3==1.26.11
    # via requests
wcwidth==0.2.5
    # via prompt-toolkit
zipp==3.11.0
    # via
    #   importlib-metadata
    #   importlib-resources

# The following packages are considered to be unsafe in a requirements file:
# setuptools
