=== debian/changelog ===
hipsparse (5.5.1-1) unstable; urgency=medium

  * New upstream version 5.5.1
  * d/p/0006-use-local-mathjax.patch: fix path to MathJax.js
  * d/rules: enable verbose sphinx build

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 01 Aug 2023 00:34:31 -0600

hipsparse (5.3.3+dfsg-4) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 12 Jul 2023 01:37:34 -0600

hipsparse (5.3.3+dfsg-3) experimental; urgency=medium

  * Add libhipsparse0-tests package for autopkgtests.
  * Add libhipsparse-doc package for documentation.
  * d/libhipsparse0.symbols: add build-depends-package
  * d/p/0002-spellcheck.patch: fix lint
  * d/control: fix maintainer name
  * d/rules: enable hardening flags

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 08 Jul 2023 03:55:19 -0600
