=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipsparse-$1.tar.gz%" \
    https://github.com/rocmsoftwareplatform/hipsparse/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
